# -*- coding: cp1251 -*-
from collections import deque


def bfs(start, stamina, graph, n):
    visited = [False] * (n + 1)
    visited[start] = True
    queue = deque([(start, 0)])
    guarded = set()

    while queue:
        node, dist = queue.popleft()
        if dist > stamina:
            continue
        guarded.add(node)

        for neighbor in graph[node]:
            if not visited[neighbor]:
                visited[neighbor] = True
                queue.append((neighbor, dist + 1))

    return guarded


def find_guarded_warehouses(n, m, k, roads, guards):
    graph = [[] for _ in range(n + 1)]

    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded_warehouses = set()

    for p, stamina in guards:
        guarded_warehouses.update(bfs(p, stamina, graph, n))

    guarded_warehouses = sorted(guarded_warehouses)
    return len(guarded_warehouses), guarded_warehouses


n, m, k = map(int, input().split())

roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

count, guarded = find_guarded_warehouses(n, m, k, roads, guards)

print(count)
if count > 0:
    print(" ".join(map(str, guarded)))