# -*- coding: cp1251 -*-
import math


def solve(n, points):
    dist = [[0] * n for _ in range(n)]
    for i in range(n):
        for j in range(n):
            if i != j:
                dist[i][j] = math.sqrt((points[i][0] - points[j][0]) ** 2 + (points[i][1] - points[j][1]) ** 2)

    INF = float('inf')
    dp = [[INF] * n for _ in range(1 << n)]

    for i in range(n):
        dp[1 << i][i] = 0

    for mask in range(1 << n):
        for u in range(n):
            if dp[mask][u] < INF:
                for v in range(n):
                    if (mask & (1 << v)) == 0:
                        new_mask = mask | (1 << v)
                        dp[new_mask][v] = min(dp[new_mask][v], dp[mask][u] + dist[u][v])

    final_mask = (1 << n) - 1
    result = min(dp[final_mask][i] for i in range(n))
    return result


n = int(input())
points = [tuple(map(int, input().split())) for _ in range(n)]

result = solve(n, points)
print(f"{result:.12f}")